@echo off
REM Seamonkey420's SageTV Batch File
REM created on: 3/14/05
REM RECOMMENDED TO TEST IN A TEMP DIR FIRST!!

REM Setup as is, it will encode mpg to divx, then 
REM clean up the log, txt, ccno and VPrj files
REM Then moves the avi file to a new folder (odir)
REM Then finally deletes the original mpg

REM 3/15/05: Added creation of subfolders with date encoded
REM and also allows date variable to be globally available
REM and added in cleanup of orphan files

REM 3/19/05: Updated date parsing/folder to be more accurate
REM also added in new functionality to create an embeded webpage
REM for each movie file created, is created in the same folder as
REM avi is encoded to! 

REM Be sure to put this batch file in the same folder as Virtualdub
REM ALSO Be sure to create a .vcf settings file in Virtualdub
REM This file then needs to be saved in the same folder as virtualdub.exe and this batch file
REM And the embedE.txt and the embedS.txt need to be created in this same directory/folder



REM parses month, day, and year into mm , dd, yyyy formats to create folders off of!
FOR /F "TOKENS=1* DELIMS= " %%A IN ('DATE/T') DO SET CDATE=%%B
FOR /F "TOKENS=1,2 eol=/ DELIMS=/ " %%A IN ('DATE/T') DO SET mm=%%B
FOR /F "TOKENS=1,2 DELIMS=/ eol=/" %%A IN ('echo %CDATE%') DO SET dd=%%B
FOR /F "TOKENS=2,3 DELIMS=/ " %%A IN ('echo %CDATE%') DO SET yyyy=%%B
SET date=%mm%%dd%%yyyy%

REM SETS SCRIPT VARIABLES, ie folder paths for files to be encoded
REM idir = the directory that sageTV saves mpg recordings to
REM odir = folder where divx avi files will be saved and webpages

set idir=T:\Recorded Shows
set odir=T:\Encoded Shows


REM This line checks for a .VPrj file in the idir location.
REM If it finds the file, it will first create a folder with todays date using mmddyyyy format
REM into the odir folder and it will then call virtualdub.exe w/the parameters 
REM and the .vcf profile for virtualdub and encode the mpg into divx avi

for /f "tokens=1 delims=." %%i in ('dir /s/b "%idir%\*-?.VPrj"') do if EXIST "%%i.mpg" (md "%odir%\%date%") 2>&1
for /f "tokens=1 delims=." %%i in ('dir /s/b "%idir%\*-?.VPrj"') do if EXIST "%%i.VPrj" (virtualdub.exe /s"tvshows.vcf" -p"%%i.mpg","%%i.avi" -q /r /x /c)


REM this section cleans up the old files and moves the avi to the odir\date folder

for /f "tokens=1 delims=." %%i in ('dir /b "%idir%\*-?.avi"') do if EXIST "%idir%\%%i.avi" (move "%idir%\%%i.avi" "%odir%\%date%\%%i.avi")
for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%odir%\%date%\%%i.avi" (del "%idir%\%%i.log")
for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%odir%\%date%\%%i.avi" (del "%idir%\%%i.txt")
for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%odir%\%date%\%%i.avi" (del "%idir%\%%i.VPrj")
for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%odir%\%date%\%%i.avi" (del "%idir%\%%i.ccno")

REM This line removes the original mpg movie if the avi is created and moved successfully to the odir

for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%idir%\%%i.mpg" (del "%idir%\%%i.mpg
)

REM These lines create a web page for each movie encoded, embeds into page, play movie from page!
REM NOTE! this again requires the embedE.txt and the embedS.txt to be located in the same folder
REM as virtaul, this batch file, and the .vcf profile!


for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%odir%\%date%\%%i.avi" (type embedS.txt > 

"%odir%\%date%\%%i.html")
for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%odir%\%date%\%%i.avi" (echo ^<param 

name="fileName" value="%odir%\%date%\%%i.avi"^> >> "%odir%\%date%\%%i.html")
for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%odir%\%date%\%%i.avi" (echo ^<embed 

type="application/x-mplayer2" pluginspage="http://www.microsoft.com/Windows/MediaPlayer/" src="%odir%\%date%\%%i.avi" 

name="MediaPlayer1" width=280 height=256 autostart=1 showcontrols=1 volume=-450^> >> "%odir%\%date%\%%i.html")
for /f "tokens=1 delims=." %%i in ('dir /b "%odir%\%date%\*-?.avi"') do if EXIST "%odir%\%date%\%%i.avi" (type embedE.txt >> 

"%odir%\%date%\%%i.html")


REM Cleans up any orphaned files, looks to see if there the mpg exists, if not, deletes the
REM orphaned files

for /f "tokens=1 delims=." %%i in ('dir /b "%idir%\*-?.txt"') do if NOT EXIST "%idir%\%%i.mpg" (del "%idir%\%%i.log")
for /f "tokens=1 delims=." %%i in ('dir /b "%idir%\*-?.txt"') do if NOT EXIST "%idir%\%%i.mpg" (del "%idir%\%%i.ccno")
for /f "tokens=1 delims=." %%i in ('dir /b "%idir%\*-?.txt"') do if NOT EXIST "%idir%\%%i.mpg" (del "%idir%\%%i.VPrj")
for /f "tokens=1 delims=." %%i in ('dir /b "%idir%\*-?.txt"') do if NOT EXIST "%idir%\%%i.mpg" (del "%idir%\%%i.txt")



REM This will then call windows media encoder script to then broadcast all the newly encoded files!
REM Commented out for now, not sure if totally works yet.
REM for /f "tokens=1 delims=." %%i in ('dir /b "%bdir%\*-?.%filetype%"') do if EXIST "%bdir%\%%i.%filetype%" (cscript.exe wmcmd.vbs -input "%bdir%\%%i.%filetype%" -author seamonkey420 -description %%i -broadcast %port% -loadprofile tvshows.prx)
